// AccessReportsListView.cpp : implementation of the CAccessReportsListView class
//

#include "stdafx.h"
#include "AccessReportViewer.h"

#include "AccessReportViewerDoc.h"
#include "AccessReportsListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAccessReportsListView

IMPLEMENT_DYNCREATE(CAccessReportsListView, CTreeView)

BEGIN_MESSAGE_MAP(CAccessReportsListView, CTreeView)
	//{{AFX_MSG_MAP(CAccessReportsListView)
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CTreeView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAccessReportsListView construction/destruction

CAccessReportsListView::CAccessReportsListView()
{
	m_pAccessReports = NULL;
}

CAccessReportsListView::~CAccessReportsListView()
{
	delete m_pAccessReports;
	m_pAccessReports = NULL;
}

BOOL CAccessReportsListView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAccessReportsListView drawing

void CAccessReportsListView::OnDraw(CDC* pDC)
{
	CAccessReportViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}


/////////////////////////////////////////////////////////////////////////////
// CAccessReportsListView printing

BOOL CAccessReportsListView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CAccessReportsListView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CAccessReportsListView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CAccessReportsListView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	FillTreeView();
}

/////////////////////////////////////////////////////////////////////////////
// CAccessReportsListView diagnostics

#ifdef _DEBUG
void CAccessReportsListView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CAccessReportsListView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CAccessReportViewerDoc* CAccessReportsListView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAccessReportViewerDoc)));
	return static_cast<CAccessReportViewerDoc*>(m_pDocument);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAccessReportsListView message handlers
void CAccessReportsListView::FillTreeView()
{
	CWaitCursor cursor;

	if (m_pDocument)
	{
		m_pAccessReports = static_cast<CAccessReportViewerDoc*>(m_pDocument)->GetAccessReports();
		if (m_pAccessReports)
		{
			for (int i = 0; i < m_pAccessReports->m_reports.GetSize(); i++)
			{
				HTREEITEM hItem = GetTreeCtrl().InsertItem(m_pAccessReports->m_reports[i]);
				GetTreeCtrl().SetItemData(hItem, (DWORD)&m_pAccessReports->m_reports[i]);
			}
		}
	}
}

void CAccessReportsListView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CWaitCursor wait;

	CTreeView::OnLButtonDblClk(nFlags, point);

	if (m_pDocument && m_pAccessReports)
	{
		HTREEITEM hNewSel = GetTreeCtrl().HitTest(point, &nFlags);
		if (hNewSel)
		{
			CString* pstrReportName = reinterpret_cast<CString*>(GetTreeCtrl().GetItemData(hNewSel));
			if (pstrReportName)
			{
				m_pAccessReports->SaveAsHtml(*pstrReportName, GetApplicationFolder());

				CString strHtmlFileName = GetApplicationFolder() + CString(*pstrReportName) + CString(_T(".html"));
				m_pDocument->UpdateAllViews(this, WM_NEWREPORT, reinterpret_cast<CObject*>(&strHtmlFileName));
			}
		}
	}
}

CString CAccessReportsListView::GetApplicationFolder()
{
	CString strDir = "";
	char szBuf[MAX_PATH];
	::GetModuleFileName(AfxGetInstanceHandle(), szBuf, MAX_PATH);
	strDir = szBuf;
	int iIdx = strDir.ReverseFind('\\');
	if (-1 < iIdx)
	{
		strDir = strDir.Left(iIdx);
#ifdef _DEBUG
		iIdx = strDir.ReverseFind('\\');
		if (-1 < iIdx)
		{
			CString strDebug = strDir.Mid(iIdx);
			if (!strDebug.CompareNoCase("\\debug"))
			{
				strDir = strDir.Left(iIdx);
			}
		}
#endif
	}
	strDir += "\\";
	return(strDir);
}

void CAccessReportsListView::OnFilePrint() 
{
	m_pAccessReports->LoadAllReports();
}
